

#POGO = ../../../pogo2/trunk/libpogo
POGO=pogo

#if CFLAGS == STATIC
CFLAGS += -Imodplug -Imodplug/libmodplug -Iuadeplugin
LIBS += -lsidplay -luade
OBJS += sidplugin/sidplugin.o modplugin/modplugin.o uadeplugin/uadeplugin.o uadeplugin/uadecontrol.o uadeplugin/uadeconf.o uadeplugin/eagleplayer.o uadeplugin/amifilemagic.o uadeplugin/md5.o
#endif

CFLAGS += -g `$(PREFIX)sdl-config --cflags` -I$(POGO)/include -I/include -Izip -Izlib -DFB16

LD = $(PREFIX)g++
CC = $(PREFIX)gcc
CXX = $(PREFIX)g++

LIBS += `$(PREFIX)sdl-config --libs`

OBJS += Equalizer.o Input.o MusicPlayer.o main.o Fifo.o FileList.o SDLScreen.o ZipFileList.o fft/CMP_fft.o console.o device.o font.o screen.o

$(OBJDIR)/%.o : %.c
	$(CC) -c $(CFLAGS) $< -o $@

$(OBJDIR)/%.o : $(POGO)/src/%.c
	$(CC) -c $(CFLAGS) $< -o $@

$(OBJDIR)/%.o : %.cpp
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)/%.o : %.S
	$(AS) $(ASFLAGS) $< -o $@

$(OBJDIR)/%.o : %.s
	$(AS) $(ASFLAGS) $< -o $@

ZOBJS = $(patsubst %.c,%.o,$(wildcard zlib/*.c))
ZIPOBJS = $(patsubst %.c,%.o,$(wildcard zip/*.c))
PLUGOBJS = $(patsubst %.cpp,%.o,$(wildcard modplug/*.cpp))

OBJFILES = $(addprefix $(OBJDIR)/,$(OBJS) $(ZOBJS) $(ZIPOBJS) $(PLUGOBJS))

all : $(OBJDIR) retroblip$(EXT)

$(OBJDIR) :
	mkdir -p $(OBJDIR)
	mkdir -p $(OBJDIR)/zip
	mkdir -p $(OBJDIR)/zlib
	mkdir -p $(OBJDIR)/fft
	mkdir -p $(OBJDIR)/modplug
	mkdir -p $(OBJDIR)/sidplugin
	mkdir -p $(OBJDIR)/modplugin
	mkdir -p $(OBJDIR)/uadeplugin


retroblip$(EXT) : $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -o retroblip$(EXT) $(OBJFILES) $(LIBS)
	cp retroblip$(EXT) db_retroblip$(EXT)
	$(PREFIX)strip retroblip$(EXT)
	
clean :
	rm -rf $(OBJFILES) retroblip$(EXT)
