
TARGET = oldplay

# Flags for a static build - TODO: Support dynamic linked plugins

CFLAGS += -Imodplug/libmodplug -I/usr/local/include -I/include -Ipogo/include
CFLAGS += -g `$(PREFIX)sdl-config --cflags` -DFB16
LIBS += -lsidplay -luade -lmad `$(PREFIX)sdl-config --libs`
OBJS += PlayList.o Equalizer.o Input.o MusicPlayer.o main.o Fifo.o FileList.o SDLScreen.o ZipFileList.o

MODULES += pogo/src zlib zip modplug gme fft uadeplugin madplugin sidplugin modplugin gmeplugin libid3tag



############################## NORMALLY DONT TOUCH ANYTHING BELOW ###########################

LD = $(PREFIX)g++
CC = $(PREFIX)gcc
CXX = $(PREFIX)g++

# Implicit rules

$(OBJDIR)/%.o : %.c
	$(CC) -c $(CFLAGS) $< -o $@

$(OBJDIR)/%.o : %.cpp
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)/%.o : %.S
	$(AS) $(ASFLAGS) $< -o $@

$(OBJDIR)/%.o : %.s
	$(AS) $(ASFLAGS) $< -o $@
	
$(OBJDIR)/% :
	mkdir -p $@

	
CFLAGS += $(addprefix -I,$(MODULES))

MODULEOBJS = $(patsubst %.cpp,%.o, $(wildcard $(addsuffix /*.cpp,$(MODULES))))
MODULEOBJS += $(patsubst %.c,%.o, $(wildcard $(addsuffix /*.c,$(MODULES))))

OBJFILES = $(addprefix $(OBJDIR)/,$(OBJS) $(MODULEOBJS))
OBJDIRS = $(OBJDIR) $(addprefix $(OBJDIR)/, $(MODULES))

all : $(OBJDIRS) $(OBJFILES) $(TARGET)$(EXT) 


$(OBJDIR) :
	mkdir -p $(OBJDIR)


$(TARGET)$(EXT) : $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -o $(TARGET)$(EXT) $(OBJFILES) $(LIBS)
	cp $(TARGET)$(EXT) db_$(TARGET)$(EXT)
	$(PREFIX)strip $(TARGET)$(EXT)
	
clean :
	rm -rf $(OBJFILES) $(TARGET)$(EXT)
